#include <unistd.h>
#include <stdlib.h>
#include <gtk/gtk.h>
#include "back.xpm"
#include "default1.xpm"

GtkWidget *window;
GtkWidget *scroll;
GdkPixmap *gdk_pixmap1; /* global and why not */
GdkPixmap *gdk_pixmap2; /* global and why not */
GdkBitmap *mask2;
GdkGC *gc;
gint x, y;

GtkWidget* get_widget (GtkWidget*, gchar*);

void animate(GtkWidget *widget, gpointer data) {
	GtkStyle *style;
	GdkBitmap *mask1;
	GdkPixmap *tmp;
	GtkWidget *pixmap;
	GdkPixmap *drawing;
	gint pause;

	if(x == 460)
		x = 0;
	else
		x += 5;
	if(y == 460)
		y = 0;
	else
		y += 10;

	tmp = get_widget(window, "display");
//	if(tmp)
		gtk_widget_destroy(tmp);

	gtk_widget_realize(window);
	style = gtk_widget_get_style(window);

//	drawing = gdk_pixmap_ref(gdk_pixmap1);
	drawing = gdk_pixmap_create_from_xpm_d(
			window->window, &mask1,
			&style->bg[GTK_STATE_NORMAL], back_xpm);

	/* Combine 2 images here */
	gdk_gc_set_clip_origin(gc, x, y);
	gdk_draw_pixmap(drawing, gc, gdk_pixmap2, 0, 0, x, y, 40, 40);

	/* Put image to a pixmap */

	pixmap = gtk_pixmap_new(drawing, NULL);
	gtk_object_set_data(GTK_OBJECT(window), "display", pixmap);
	gtk_scrolled_window_add_with_viewport(
			GTK_SCROLLED_WINDOW(scroll), pixmap);
	gtk_widget_show(pixmap);
}

void main(gint argc, gchar *argv[]) {
	GtkStyle *style;
	GtkWidget *pixmap;
	GdkBitmap *mask1;
	GtkWidget *vbox;

	gtk_init(&argc, &argv);

	window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	style = gtk_widget_get_style(window);

	gtk_signal_connect(GTK_OBJECT(window), "delete_event",
			GTK_SIGNAL_FUNC(gtk_exit), NULL);
	gtk_signal_connect(GTK_OBJECT(window), "destroy",
			GTK_SIGNAL_FUNC(gtk_exit), NULL);

	vbox = gtk_vbox_new(FALSE, 0);
	gtk_widget_show(vbox);
	gtk_container_add(GTK_CONTAINER(window), vbox);

	scroll = gtk_scrolled_window_new(NULL, NULL);
	gtk_object_set_data(GTK_OBJECT(window), "scroll", scroll);
	gtk_widget_show(scroll);
	gtk_box_pack_start(GTK_BOX(vbox), scroll, TRUE, TRUE, 0);

	gtk_widget_realize(window);

	gdk_pixmap1 = gdk_pixmap_create_from_xpm_d(
			window->window, &mask1,
			&style->bg[GTK_STATE_NORMAL], back_xpm);

	gtk_widget_realize(window);

	gdk_pixmap2 = gdk_pixmap_create_from_xpm_d(
			window->window, &mask2,
			&style->bg[GTK_STATE_NORMAL], default1_xpm);

	gc = gdk_gc_new(gdk_pixmap2);
	gdk_gc_set_clip_mask(gc, mask2);

	pixmap = gtk_pixmap_new(gdk_pixmap1, mask1);
	gtk_object_set_data(GTK_OBJECT(window), "display", pixmap);

	gtk_scrolled_window_add_with_viewport(
			GTK_SCROLLED_WINDOW(scroll), pixmap);
	gtk_widget_show(pixmap);

	gtk_widget_show(window);

//	gtk_widget_set_usize(window, 510, 510);

	x = y = 0;
	gtk_idle_add(GTK_SIGNAL_FUNC(animate), NULL);

	gtk_main();
}

GtkWidget*
get_widget                             (GtkWidget       *widget,
                                        gchar           *widget_name)
{
  GtkWidget *found_widget;

  if (widget->parent)
    widget = gtk_widget_get_toplevel (widget);
  found_widget = (GtkWidget*) gtk_object_get_data (GTK_OBJECT (widget),
                                                   widget_name);
  if (!found_widget)
    g_warning ("Widget not found: %s", widget_name);
  return found_widget;
}
